//  A Model Railroad Speedometer and Crossing Flasher for any scale and any size layout
//  11/26/14         Getting the Arduino in on the model railroad fun!
#include <Wire.h>
#include <LiquidCrystal.h>
int flasherPin1 = 12;
int flasherPin2 = 11;
const int Threshold = 500;
int WestSensorPin1 = A0;
int EastSensorPin1 = A1;
int WestSensorPin2 = A2;
int EastSensorPin2 = A3;
boolean State;
int dwell = 500;
LiquidCrystal lcd(4,5,6,7,8,9);  // pins to use for RE,E,& 4 bits
unsigned long start, finish, elapsed;
float Scale = 87.0;  // set for HO scale
float Distance = 5.0;   // distance between speed sensors (inches)
unsigned long ScaleSpeed; 

void setup()
{
  pinMode(flasherPin1, OUTPUT);
  pinMode(flasherPin2, OUTPUT);
  lcd.begin(20,4);
  lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("     BLOCK CLEAR");  
}
void loop()
{
 delay(20);   // slow down for photoresistors to stabilize
  if (analogRead(WestSensorPin1) > Threshold)   // check for a westbound train
   {                            // a Westbound is 'on the bell'
    flashDriver(true);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("   WESTBOUND TRAIN");
      while(analogRead(WestSensorPin2) < Threshold)
       {  flashDriver(true);  // waiting for train to get to crossing
       }
      while(analogRead(WestSensorPin2) > Threshold)  // waiting to clear crossing
       { flashDriver(true);
       }
    delay(100);   
    start = millis();  // start timing
    while(analogRead(EastSensorPin1) < Threshold)  // short train, wait
       {
       }
    delay(100);
      while(analogRead(EastSensorPin1) > Threshold) // waiting to clear timer
        {
        } 
    delay(100);
    finish = millis(); // end speed time
           //  calculate & display speed data on LCD   
    elapsed = finish - start;  
    ScaleSpeed  = (Distance * Scale * 3600);
    ScaleSpeed = ScaleSpeed * (1000/12);
    ScaleSpeed = ScaleSpeed / (5280 * elapsed); 
    WaitTillClear();
   }
   // Now Check for eastbound train   
  if (analogRead(EastSensorPin1) > Threshold) // an eastbound train is 'on the bell'
   { 
    flashDriver(true);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("   EASTBOUND TRAIN");
      while(analogRead(EastSensorPin2) < Threshold)
       {  flashDriver(true);  // waiting for train to get to crossing
       }
      while(analogRead(EastSensorPin2) > Threshold)  // waiting to clear crossing
       { flashDriver(true);
       }
       delay(100);
       start = millis();  // start timing
       flashDriver(false);  
      while(analogRead(WestSensorPin1) < Threshold) // short train?
        {}
       delay(100);
      while(analogRead(WestSensorPin1) > Threshold) // time train
        {} 
    delay(100);
    finish = millis(); // end speed time
       //  display speed data on LCD   
    elapsed = finish - start;    // done,  display speed  
    ScaleSpeed  = (Distance * Scale * 3600);
    ScaleSpeed = ScaleSpeed * (1000/12);
    ScaleSpeed = ScaleSpeed / (5280 * elapsed); 
    WaitTillClear();
    }
}  // Start the endless polling loop over again
 
                // ***** THESE ARE THE SUBROUTINES ... *****
 void WaitTillClear() // show speed then clear the screen
 {
  lcd.setCursor(0,2);
  lcd.print("   Train Speed: ");
  lcd.print(int(ScaleSpeed));
  lcd.setCursor(0,3);
  lcd.print("      Scale MPH"); 
  delay(7000);
  lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("    BLOCK CLEAR");
 } 
 
 boolean flashDriver(boolean State) // Flasher Driver Sub
 {
     if(State == true)
     {
       digitalWrite(flasherPin1, HIGH);
       delay(dwell);
       digitalWrite(flasherPin1, LOW);
       delay(dwell);
       digitalWrite(flasherPin2, HIGH);
       delay(dwell);
       digitalWrite(flasherPin2, LOW);
       delay(dwell);
     }
    else
     {
       digitalWrite(flasherPin1, LOW);
       digitalWrite(flasherPin2, LOW);
     }
 }  
 
